package com.artfess.yhxt.specialproject.controller;


import com.artfess.base.annotation.ApiGroup;
import com.artfess.base.constants.ApiGroupConsts;
import com.artfess.base.context.BaseContext;
import com.artfess.base.model.CommonResult;
import com.artfess.base.query.FieldRelation;
import com.artfess.base.query.PageList;
import com.artfess.base.query.QueryFilter;
import com.artfess.base.query.QueryOP;
import com.artfess.uc.util.ContextUtil;
import com.artfess.yhxt.specialproject.model.BizProjectSafetyEnvironmentalRecord;
import com.artfess.yhxt.specialproject.vo.BizProjectSafetyEnvironmentalRecordVo;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import net.hasor.utils.StringUtils;
import org.springframework.web.bind.annotation.*;
import com.artfess.base.controller.BaseController;
import com.artfess.yhxt.specialproject.model.BizProjectSafetyEnvironmentalRecord;
import com.artfess.yhxt.specialproject.manager.BizProjectSafetyEnvironmentalRecordManager;

import javax.annotation.Resource;
import java.time.LocalDate;
import java.util.Arrays;
import java.util.List;

/**
 * 工程安全环保记录表 前端控制器
 *
 * @company 阿特菲斯信息技术有限公司
 * @author wangping
 * @since 2021-08-11
 */
@RestController
@RequestMapping("/bizProjectSafetyEnvironmentalRecord/v1/")
@Api(tags = "工程安全环保记录管理")
@ApiGroup(group = {ApiGroupConsts.GROUP_BIZ})
public class BizProjectSafetyEnvironmentalRecordController extends BaseController<BizProjectSafetyEnvironmentalRecordManager, BizProjectSafetyEnvironmentalRecord> {

    @Resource
    private BaseContext baseContext;

    @RequestMapping(value = "/saveProjectSafetyEnvironmentalRecord",method = RequestMethod.POST,produces = {"application/json; charset=utf-8"})
    @ApiOperation(value = "保存,修改工程安全环保记录",httpMethod = "POST")
    public CommonResult<String> saveEngineeringProject(@ApiParam(name = "bizProjectSafetyEnvironmentalRecord",value = "工程安全环保记录对象") @RequestBody BizProjectSafetyEnvironmentalRecord bizProjectSafetyEnvironmentalRecord) throws Exception {
        String msg = "添加成功";
        if (StringUtils.isEmpty(bizProjectSafetyEnvironmentalRecord.getId())){
            bizProjectSafetyEnvironmentalRecord.setIsDele("0");
            baseService.create(bizProjectSafetyEnvironmentalRecord);
        }else {
            baseService.update(bizProjectSafetyEnvironmentalRecord);
            msg = "修改成功";
        }
        return new CommonResult<String>(msg);
    }


    @RequestMapping(value = "/saveVo",method = RequestMethod.POST,produces = {"application/json; charset=utf-8"})
    @ApiOperation(value = "保存,修改工程安全环保记录、附件",httpMethod = "POST")
    public CommonResult<String> saveVo(@ApiParam(name = "bizProjectSafetyEnvironmentalRecordVo",value = "工程安全环保记录对象 vo") @RequestBody BizProjectSafetyEnvironmentalRecordVo bizProjectSafetyEnvironmentalRecordVo) throws Exception {
        String msg = "添加成功";
        BizProjectSafetyEnvironmentalRecord bizProjectSafetyEnvironmentalRecord = bizProjectSafetyEnvironmentalRecordVo.getBizProjectSafetyEnvironmentalRecord();
        if (StringUtils.isEmpty(bizProjectSafetyEnvironmentalRecord.getId())){
            bizProjectSafetyEnvironmentalRecord.setIsDele("0");
            bizProjectSafetyEnvironmentalRecord.setRecordDate(LocalDate.now());
            bizProjectSafetyEnvironmentalRecord.setRecordUserId(ContextUtil.getCurrentUserId());
            bizProjectSafetyEnvironmentalRecord.setRecordUserName(ContextUtil.getCurrentUserName());
            baseService.saveVo(bizProjectSafetyEnvironmentalRecordVo);
        }else {
            baseService.updateVo(bizProjectSafetyEnvironmentalRecordVo);
            msg = "修改成功";
        }
        return new CommonResult<String>(msg);
    }
    @GetMapping(value = "getVo/{id}")
    @ApiOperation(value = "根据ID查询工程安全环保记录、附件信息",httpMethod = "GET",notes = "根据ID查询工程安全环保记录、附件信息")
    public BizProjectSafetyEnvironmentalRecordVo getVo(@ApiParam(name = "id",value = "业务对象主键",required = true)@PathVariable String id) throws Exception{
        return baseService.getVo(id);
    }


    @RequestMapping(value = "getJson",method = RequestMethod.POST,produces = {"application/json;charset=utf-8" })
    @ApiOperation(value = "分页查询工程安全环保记录信息",httpMethod ="POST")
    public PageList<BizProjectSafetyEnvironmentalRecord> getJson(@ApiParam(name = "queryFilter",value = "分页查询信息")@RequestBody QueryFilter<BizProjectSafetyEnvironmentalRecord> queryFilter){
        queryFilter.addFilter("is_dele_","0", QueryOP.EQUAL);
        if (org.apache.commons.lang3.StringUtils.isNotEmpty(baseContext.getCurrentOrgId()) ){

        }
        PageList<BizProjectSafetyEnvironmentalRecord> pageList = baseService.queryBizProjectSafetyEnvironmentalRecord(queryFilter);
        return pageList;
    }

    @GetMapping(value = "get/{id}")
    @ApiOperation(value = "根据ID查询工程安全环保记录信息",httpMethod = "GET",notes = "根据ID查询工程安全环保记录信息")
    public BizProjectSafetyEnvironmentalRecord get(@ApiParam(name = "id",value = "业务对象主键",required = true)@PathVariable String id) throws Exception{
        return baseService.getBizProjectSafetyEnvironmentalRecordById(id);
    }

    @DeleteMapping(value = "/removes")
    @ApiOperation(value = "批量删除工程安全环保记录信息",httpMethod = "DELETE",notes = "批量删除工程安全环保记录信息")
    public CommonResult<String> removes(@ApiParam(name = "ids",value = "对各主键用逗号分隔",required = true) @RequestParam String... ids) throws Exception{
        baseService.removeByIds(Arrays.asList(ids));
        return new CommonResult<String>(true,"删除成功");
    }

    @RequestMapping(value = "/updateSafetyEnvironmentalRecord",method = RequestMethod.DELETE,produces = {"application/json;charset=utf-8"})
    @ApiOperation(value = "逻辑删除工程安全环保记录信息",httpMethod = "DELETE",notes = "逻辑删除工程安全环保记录信息")
    public CommonResult<String> updateSafetyEnvironmentalRecord(@ApiParam(name = "ids",value = "ID集合以，隔开",required = true)
                                              @RequestParam(value = "ids",required = true)String ids)throws Exception{
        if (StringUtils.isNotBlank(ids)){
            List<String> idsList = Arrays.asList(ids.split(","));
            UpdateWrapper<BizProjectSafetyEnvironmentalRecord> updateWrapper = new UpdateWrapper<>();
            updateWrapper.in("id_",idsList);
            updateWrapper.set("is_dele_","1");
            baseService.update(null,updateWrapper);
        }
        return new CommonResult<>(true,"删除成功");
    }

}
